Name:           tmt
Version:        1.37.dev888
Release:        1.20240924121451489629.pr2985.34.gbdea0cfa%{?dist}
Summary:        Test Management Tool

License:        MIT
URL:            https://github.com/teemtee/tmt
Source0:        tmt-1.37.0.dev34+gbdea0cfa.tar.gz

BuildArch:      noarch
BuildRequires:  python3-devel

Requires:       git-core rsync sshpass

%if 0%{?fedora} < 40
Obsoletes:      python3-tmt < %{version}-%{release}
Provides:       tmt-report-html == %{version}-%{release}
Obsoletes:      tmt-report-html < %{version}-%{release}
Provides:       tmt-report-junit == %{version}-%{release}
Obsoletes:      tmt-report-junit < %{version}-%{release}
Provides:       tmt-report-polarion == %{version}-%{release}
Obsoletes:      tmt-report-polarion < %{version}-%{release}
Provides:       tmt-report-reportportal == %{version}-%{release}
Obsoletes:      tmt-report-reportportal < %{version}-%{release}
%endif

Recommends:     bash-completion

%py_provides    python3-tmt

%global _metapackage_description %{expand:
This is a metapackage bringing in extra dependencies for tmt.
It contains no code, just makes sure the dependencies are installed.}

%description
The tmt Python module and command line tool implement the test
metadata specification (L1 and L2) and allows easy test execution.

%pyproject_extras_subpkg -n tmt export-polarion
%pyproject_extras_subpkg -n tmt report-junit
%pyproject_extras_subpkg -n tmt report-polarion

%package -n     tmt+test-convert
Summary:        Dependencies required for tmt test import and export
Provides:       tmt-test-convert == %{version}-%{release}
%if 0%{?fedora} < 40
Obsoletes:      tmt-test-convert < %{version}-%{release}
%endif
Requires:       tmt == %{version}-%{release}
Requires:       make
Requires:       python3-bugzilla
Requires:       python3-nitrate
Requires:       python3-html2text
Requires:       python3-markdown

%description -n tmt+test-convert %_metapackage_description

%package -n     tmt+provision-container
Summary:        Dependencies required for tmt container provisioner
Provides:       tmt-provision-container == %{version}-%{release}
%if 0%{?fedora} < 40
Obsoletes:      tmt-provision-container < %{version}-%{release}
%endif
Requires:       tmt == %{version}-%{release}
Requires:       podman
Requires:       (ansible or ansible-collection-containers-podman)

%description -n tmt+provision-container %_metapackage_description

%package -n     tmt+provision-virtual
Summary:        Dependencies required for tmt virtual machine provisioner
Provides:       tmt-provision-virtual == %{version}-%{release}
%if 0%{?fedora} < 40
Obsoletes:      tmt-provision-virtual < %{version}-%{release}
%endif
Requires:       tmt == %{version}-%{release}
Requires:       python3-testcloud >= 0.9.13
Requires:       libvirt-daemon-config-network
Requires:       openssh-clients
Requires:       (ansible or ansible-core)
# Recommend qemu system emulators for supported arches
Recommends:     qemu-kvm-core
%if 0%{?fedora}
Recommends:     qemu-system-aarch64-core
Recommends:     qemu-system-ppc-core
Recommends:     qemu-system-s390x-core
Recommends:     qemu-system-x86-core
%endif

%description -n tmt+provision-virtual %_metapackage_description

%package -n     tmt+provision-beaker
Summary:        Dependencies required for tmt beaker provisioner
Provides:       tmt-provision-beaker == %{version}-%{release}
%if 0%{?fedora} < 40
Obsoletes:      tmt-provision-beaker < %{version}-%{release}
%endif
Requires:       tmt == %{version}-%{release}
Requires:       python3-mrack-beaker

%description -n tmt+provision-beaker %_metapackage_description

# Replace with pyproject_extras_subpkg at some point
%package -n     tmt+all
Summary:        Extra dependencies for the Test Management Tool
Provides:       tmt-all == %{version}-%{release}
%if 0%{?fedora} < 40
Obsoletes:      tmt-all < %{version}-%{release}
%endif
Requires:       tmt+test-convert == %{version}-%{release}
Requires:       tmt+export-polarion == %{version}-%{release}
Requires:       tmt+provision-container == %{version}-%{release}
Requires:       tmt+provision-virtual == %{version}-%{release}
Requires:       tmt+provision-beaker == %{version}-%{release}
Requires:       tmt+report-junit == %{version}-%{release}
Requires:       tmt+report-polarion == %{version}-%{release}

%description -n tmt+all
All extra dependencies of the Test Management Tool. Install this
package to have all available plugins ready for testing.

%prep
%autosetup -p1 -n tmt-1.37.0.dev34+gbdea0cfa

%generate_buildrequires
%pyproject_buildrequires

%build
export SETUPTOOLS_SCM_PRETEND_VERSION=%{version}
%pyproject_wheel

%install
%pyproject_install
%pyproject_save_files tmt

mkdir -p %{buildroot}%{_mandir}/man1
install -pm 644 tmt.1 %{buildroot}%{_mandir}/man1
mkdir -p %{buildroot}%{_datadir}/bash-completion/completions
install -pm 644 completions/bash/%{name} %{buildroot}%{_datadir}/bash-completion/completions/%{name}
mkdir -p %{buildroot}/etc/%{name}/
install -pm 644 %{name}/steps/provision/mrack/mrack* %{buildroot}/etc/%{name}/

%check
%pyproject_check_import

%files -n tmt -f %{pyproject_files}
%doc README.rst examples
%{_bindir}/tmt
%{_mandir}/man1/tmt.1.gz
%{_datadir}/bash-completion/completions/%{name}

%files -n tmt+provision-container -f %{_pyproject_ghost_distinfo}
%files -n tmt+provision-virtual -f %{_pyproject_ghost_distinfo}
%files -n tmt+test-convert -f %{_pyproject_ghost_distinfo}
%files -n tmt+provision-beaker -f %{_pyproject_ghost_distinfo}
%config(noreplace) %{_sysconfdir}/%{name}/mrack*
%files -n tmt+all -f %{_pyproject_ghost_distinfo}

%changelog
* Tue Sep 24 2024 Packit <hello@packit.dev> - 1.37.dev888-1.20240924121451489629.pr2985.34.gbdea0cfa
- Adjust the example to be more realistic (Petr Šplíchal)
- Simplify the implementation a bit (Petr Šplíchal)
- Fix versionadded to current one (Ismail Ibrahim Quwarah)
- Move release note to 1.37 (Ismail Ibrahim Quwarah)
- Add `epel` release note in tmt try (Ismail Ibrahim Quwarah)
- Add `epel` documentation in tmt try (Ismail Ibrahim Quwarah)
- Add `epel` coverage test in tmt try (Ismail Ibrahim Quwarah)
- Add `epel` prepare plugin using `feature` (Ismail Ibrahim Quwarah)
- Do not traceback upon an empty docstring (#3233) (Petr Šplíchal)
- Fix the missing `f-string` in the `tmt lint` check (#3230) (Petr Šplíchal)
- Document the `known issue` label on the contribute page (#3220) (Petr Šplíchal)
- Log the information about used beakerlib libraries (#3208) (Sabart Otto)
- Add 'where', 'name' and 'order' keywords to feature schema (#3225) (Tomáš Bajer)
- Check both `stdout` and `stderr` in package manager tests (#3227) (Petr Šplíchal)
- Reportportal should note guest hostname for investigation (#3209) (Miloš Prchlík)
- Verify docs links using the sphinx-builder `linkcheck` (#2489) (Cristian Le)
- Improve template url generations (#3108) (Cristian Le)
- Move ReST rendering for CLI help into `tmt.utils` submodule (#3222) (Miloš Prchlík)
- Fix position of `hardware` filter in `mrack` request (#3211) (Miloš Prchlík)
- Drop no longer needed is_selinux_supported() (#3191) (Miloš Prchlík)
- Document steps for releasing hotfix changes (#3217) (Petr Šplíchal)
- Fix badly added info about changes in junit report plugin (#3218) (Sabart Otto)
- Fix command detection in the `out-of-session` test (#3216) (Petr Šplíchal)
- Generate JUnit files using Jinja2 instead of junit-xml (#3150) (Sabart Otto)
- Update label names used for configuring packit jobs (#3207) (Petr Šplíchal)
- Move and rename SSH master socket path to avoid path length limit (#3196) (Miloš Prchlík)
- Use consistent version names in the release notes (#3205) (Petr Šplíchal)
- Add make target for fetching base images of custom test images we build (#3190) (Miloš Prchlík)
- Pre commit bump (#3197) (Martin Hoyer)
- Move structured field into its own module under tmt.utils (#3192) (Miloš Prchlík)
- Fix quay.io builds (#3194) (Martin Hoyer)
- Drop no longer needed `apt update` from package manager tests (#3189) (Miloš Prchlík)
- Hide internal fields of provision plugins (#3181) (Miloš Prchlík)
- Explicitly state polarion report authentication limitation (#3188) (Petr Matyas)
